
clear all
% close all

lag = 0.65;

%% Load measured data
wsem = load('..\data\Girond_WSE.txt');

%% Load calculated results
% filename = '..\runs\Flow_G03_eta.txt';
filename = '..\runs\G03\b51\Flow_G03_eta.txt';
filename = '..\runs\G03\b51\mp0np015\Flow_G03_eta.txt';
filename = '..\runs\G03\b51\mp0np018\Flow_G03_eta.txt';
% filename = '..\runs\G03\b51\mp0np02\Flow_G03_eta.txt';
% filename = '..\runs\G03\b51\mp14np02\Flow_G03_eta.txt';
% filename = '..\runs\G03\b51\mp1np02\Flow_G03_eta.txt';
% filename = '..\runs\G03\b51\mp1np015\Flow_G03_eta.txt';
% filename = '..\runs\G03\b48\Flow_G03_eta.txt';
% filename = '..\runs\G03\b15\Flow_G03_eta.txt';
wsec = load(filename);
%1      5998 "Ile_Verte"
%2      6582 "Blaye"
%3      6636 "La_Reuile"
%4      8986 "PK47"
%5      13820 "Pauillac"
%6      16134 "Richard_wse"
%7      18646 "PK54"
%8      18664 "Pauillac2"
%9      21050 "Lamena1"
%10     21090 "Pauillac1"
%11     21574 "PK82A"
%12     21650 "Lamena3"
%13     24054 "PK68_vel"
%14     25292 "Lamena4"
%15     27112 "Lamena2"
%16     28842 "PK82B"
%17     29472 "Richard_vel"
ind = [6 9 8 1 3]; %Mapping between measured and calculated stations
% ind = [6 9 10 1 3]; %Mapping between measured and calculated stations
% ind = [6 9 5 1 3]; %Mapping between measured and calculated stations
% ind = [6 12 5 1 3]; %Mapping between measured and calculated stations
% ind = [6 14 5 1 3]; %Mapping between measured and calculated stations
% ind = [6 15 5 1 3]; %Mapping between measured and calculated stations
ind2 = [17 13 12 10 8 2];

%% Plotting
name{1} = 'Richard';
name{2} = 'Lamena';
name{3} = 'Pauillac';
name{4} = 'Ile Verte';
name{5} = 'La Reuile';

rmse = zeros(5,1);
nrmse = zeros(5,1);
nmae = zeros(5,1);
R2 = zeros(5,1);
bias = zeros(5,1);

% return

figure('position',[363    55   504   613])
for i=1:5
    %figure('position',[1657  309  551   257])
    subplot(5,1,i)
    plot(wsem(:,1),wsem(:,i+1),'ro','markerfacecolor','r','markersize',5)
    hold on
    plot(wsec(:,1)-lag,wsec(:,ind(i)+1),'b','linewidth',2)
    set(gca,'ylim',[-3 3],'xlim',[0 60])    
    title(name{i})
    if i==5
        xlabel('Time Elapsed, hr')
    end
    ylabel('Water Level, m')
    
    %Statistics
    xm = wsem(:,1); ym = wsem(:,i+1);
    xc = wsec(:,1)-lag; yc = wsec(:,ind(i)+1);
    yc = interp1(xc,yc,xm);
    ii = (isfinite(yc) & isfinite(ym) & xm>10);
    ym = ym(ii); yc = yc(ii);    
    rmse(i) = sqrt(mean((yc-ym).^2));
    nrmse(i) = sqrt(mean((yc-ym).^2))/(max(ym)-min(ym));
    nmae(i) = mean(abs((yc-ym)))/(max(ym)-min(ym));
    R = corrcoef(yc,ym);
    R2(i) = R(1,2).^2;
    bias(i) = mean(yc-ym);
%     figure
%     plot(ym,yc,'.')
end
% title(filename)
legend('Measured','Calculated')

disp('--- Gironde Water Level Goodness of fit statistics ---')
disp('Station    1       2       3       4      5')
fprintf(1,'RMSE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',rmse);
fprintf(1,'NRMSE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',nrmse);
fprintf(1,'NMAE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',nmae);
fprintf(1,'R^2     %7.3f,%7.3f,%7.3f,%7.3f,%7.4f\n',R2);
fprintf(1,'Bias     %7.3f,%7.3f,%7.3f,%7.3f,%7.4f\n',bias);

%% Ile Verte
figure
i=4;
plot(wsem(:,1),wsem(:,i+1),'ro','markerfacecolor','r','markersize',5)
hold on
plot(wsec(:,1)-lag,wsec(:,ind(i)+1),'b','linewidth',2)
set(gca,'ylim',[-3 3],'xlim',[0 60])
title(name{i})
xlabel('Time Elapsed, hr')
ylabel('Water Level, m')

% return
%% Load velocity data
um = load('..\data\Girond_Vel.txt');
filename = '..\runs\G03\b51\mp0np018\Flow_G03_u.txt';
uc = load(filename);
filename = '..\runs\G03\b51\mp0np018\Flow_G03_v.txt';
vc = load(filename);
s = sign(uc(:,2:end));
uc(:,2:end) = s.*sqrt(uc(:,2:end).^2+vc(:,2:end).^2);

return
%% Plotting velocity
name{1} = 'Richard';
name{2} = 'PK68';
name{3} = 'Lamena';
name{4} = 'Pauillac-1';
name{5} = 'Pauillac-2';
name{6} = 'Blaye';

rmse = zeros(6,1);
nrmse = zeros(6,1);
nmae = zeros(6,1);
R2 = zeros(6,1);
bias = zeros(6,1);
figure('position',[360   129   502   537])
for i=1:6
    %figure('position',[1657  309  551   257])
    subplot(3,2,i)
    plot(um(:,1),um(:,i*2),'o','markerfacecolor','r',...
        'markeredgecolor','r','markersize',5)
    hold on
    plot(um(:,1),um(:,i*2+1),'d','markerfacecolor','g',...
        'markeredgecolor','g','markersize',5)
    plot(uc(:,1)-lag,uc(:,ind2(i)+1),'b','linewidth',2)
    set(gca,'ylim',[-3 3],'xlim',[76 92])    
    title(name{i})
    if i==5 || i==6
        xlabel('Time Elapsed, hr')        
    end
    if i==6
        legend('Measured 1m below surface','Measured 1m above bottom','Calculated')
    end
    if i==1 || i==3 || i==5
        ylabel('Current Speed, m/s')
    end
    
    %Statistics
    xm = um(:,1); ym = um(:,i*2);
    xc = uc(:,1)-lag; yc = uc(:,ind2(i)+1);
    yc = interp1(xc,yc,xm);
    ii = (isfinite(yc) & xm>10);
    ym = ym(ii); yc = yc(ii);    
    rmse(i) = sqrt(mean((yc-ym).^2));
    nrmse(i) = sqrt(mean((yc-ym).^2))/(max(ym)-min(ym));
    nmae(i) = mean(abs((yc-ym)))/(max(ym)-min(ym));
    R = corrcoef(yc,ym);
    R2(i) = R(1,2).^2;
    bias(i) = mean(yc-ym);
%     figure
%     plot(ym,yc,'.')
end

disp('--- Gironde Velocity Goodness of fit statistics ---')
disp('Station    1       2       3       4      5      6')
fprintf(1,'RMSE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',rmse);
fprintf(1,'NRMSE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',nrmse);
fprintf(1,'NMAE    %7.4f,%7.4f,%7.4f,%7.4f,%7.4f,%7.4f\n',nmae);
fprintf(1,'R^2     %7.3f,%7.3f,%7.3f,%7.3f,%7.4f,%7.4f\n',R2);
fprintf(1,'Bias     %7.3f,%7.3f,%7.3f,%7.3f,%7.4f,%7.4f\n',bias);

return

     
